function varargout = BlebQuant(varargin)
% BlebQuant M-file for BlebQuant.fig
%      BlebQuant, by itself, creates a new BlebQuant or raises the existing
%      singleton*.
%
%      H = BlebQuant returns the handle to a new BlebQuant or the handle to
%      the existing singleton*.
%
%      BlebQuant('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_BLEBS.M with the given input arguments.
%
%      BlebQuant('Property','Value',...) creates a new BlebQuant or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before BlebQuant_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to BlebQuant_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help BlebQuant

% Last Modified by GUIDE v2.5 10-Jan-2011 20:26:21

% Begin initialization code 
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @BlebQuant_OpeningFcn, ...
                   'gui_OutputFcn',  @BlebQuant_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code


% --- Executes just before BlebQuant is made visible.
function BlebQuant_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GUI_blebs (see VARARGIN)

% Choose default command line output for BlebQuant
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes BlebQuant wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = BlebQuant_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)                 %%% For control(reference, i.e. before stroke) stack loading    
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[fname pname]=uigetfile({'*.tif','Orginal Files(*.tif)';...                
                        '*.*','all kinds of images'},...
                         'Load one stack for processing');
               a=imread(sprintf('%s%s',pname,fname),1);
               handles.im=a;
               axes(handles.axes1);
               imagesc(a,[min(min(a)),max(max(a))]);
               colormap gray
               handles.file=sprintf('%s%s',pname,fname);
               handles.path=pname;
               guidata(gcbo,handles)




% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)                 %%% For playing control stack as video 
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
for i=1:20;
    a=imread(handles.file,i);
    axes(handles.axes1)
    imagesc(a,[min(min(a)),max(max(a))]);
    colormap gray
    text(900,20,num2str(i),'color','r')
    pause(0.3)
end
    


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)                 %%% To do maximal intensity z-projection
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
sum=zeros(1024,1024);
tt=zeros(1024,1024,20);
for i=1:20;
    tt(:,:,i)=imread(handles.file,i);
end
sum=max(tt(:,:,1:20),[],3);
clear tt;
axes(handles.axes1)
imagesc(sum,[min(min(sum)),max(max(sum))])
colormap gray
handles.sum1=sum;
guidata(gcbo,handles)


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)                 %%% To do thresholding
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
expim=handles.sum1;
expim=(expim-min(min(expim)))/(max(max(expim))-min(min(expim)));           %%% to do image normalization
expim=colfilt(expim,[3,3],'sliding',@median);
expimf=imfilter(expim,0.01*ones(10,10));
th=graythresh(expim);                                                      %%% OTSU's thresholding method 
tbk=(expim>th);
pfill=sum(sum(tbk))/(1024*1024);                                           %%% quantify the dendrite density
exf=expimf(1:1000,1:1000);                                                 %%% crop the main part of the whole image to estimate the density
mf=blkproc(exf,[100,100],@mean2);
lmf=reshape(mf,[1,100]);
smf=sort(lmf,'descend');
mth=mean(smf(1:10));
tt=th*(2*mth/th*expimf+1-2*mth);                                           %%% to implement adaptive local thresholding
expbk=(expim>tt);
axes(handles.axes1)
imagesc(expbk)
colormap gray
text(size(expbk,2)-200,20,'BW of reference','color','r');
handles.conbk=expbk;
handles.pfill=pfill;
guidata(gcbo,handles)



% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)                 %%% To load test stack
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[fname pname]=uigetfile({'*.tif','Orginal Files(*.tif)';...
                         '*.*','all kinds of images'},...
                         'Load one stack for processing');
               a=imread(sprintf('%s%s',pname,fname),1);
               handles.im=a;
               axes(handles.axes2);
               imagesc(a,[min(min(a)),max(max(a))]);
               colormap(gray)
               handles.file2=sprintf('%s%s',pname,fname);
               guidata(gcbo,handles)


% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)                 %%% To display the test stack as video
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
for i=1:20;
    a=imread(handles.file2,i);
    axes(handles.axes2)
    imagesc(a,[min(min(a)),0.999*max(max(a))]);
    text(900,20,num2str(i),'color','r')
    pause(0.3)
end

% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)                 %%% To do maximal intensity z-projection
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
sum=zeros(1024,1024);
tt=zeros(1024,1024,20);
for i=1:20;
    tt(:,:,i)=imread(handles.file2,i);
end
sum=max(tt,[],3);
clear tt;
axes(handles.axes2)
imagesc(sum,[min(min(sum)),max(max(sum))])
handles.sum2=sum;
guidata(gcbo,handles)

% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)                 %%% To do thresholding
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
expim=handles.sum2;
expim=(expim-min(min(expim)))/(max(max(expim))-min(min(expim)));
expim=colfilt(expim,[3,3],'sliding',@median);
expimf=imfilter(expim,0.01*ones(10,10));
th=graythresh(expim);                                                      %%% OTSU's thresholding method 
tbk=(expim>th);
pfill=sum(sum(tbk))/(1024*1024);                                           %%% quantify the dendrite density
exf=expimf(1:1000,1:1000);                                                 %%% crop the main part of the whole image to estimate the density
mf=blkproc(exf,[100,100],@mean2);
lmf=reshape(mf,[1,100]);
smf=sort(lmf,'descend');
mth=mean(smf(1:10));
tt=th*(2*mth/th*expimf+1-2*mth);                                           %%% to implement adaptive local thresholding
expbk=(expim>tt);
axes(handles.axes2)
imagesc(expbk)
colormap gray
text(size(expbk,2)-200,20,'BW of test','color','r');



% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)                 %%% to show the unregistered result of two projected images
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
a=zeros(1024,1024,3);
a(:,:,1)=(handles.sum1-min(min(handles.sum1)))/(max(max(handles.sum1))-min(min(handles.sum1)));
a(:,:,2)=(handles.sum2-min(min(handles.sum2)))/(max(max(handles.sum2))-min(min(handles.sum2)));
figure
imagesc(a)





% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)                %%% To do registration
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[output Greg]=dftregistration(fft2(handles.sum1),fft2(handles.sum2),10);   %%% core function for registration  
reg_im=abs(ifft2(Greg));
figure
imagesc(reg_im);
hold on
text(800,20,sprintf('%s%d%s%d','Shift:',round(output(3)),',',round(output(4))),'color','r');
a=zeros(1024,1024,3);
a(:,:,1)=(handles.sum1-min(min(handles.sum1)))/(max(max(handles.sum1))-min(min(handles.sum1)));
a(:,:,2)=(reg_im-min(min(reg_im)))/(max(max(reg_im))-min(min(reg_im)));
nl=round(output(3));
nc=round(output(4));
ll=floor((1024-abs(nl)-1)/100);
cc=floor((1024-abs(nc)-1)/100);
                                                                           %%% to take the main match part 
nnl=abs(nl);
nnc=abs(nc);
figure
imagesc(a)
hold on
if nl>0;
    for i=0:ll+1
    plot([0,1024],[nl+i*100,nl+i*100],'color','r')
    end
else
    for i=0:ll+1
        plot([0,1024],[1024+nl-i*100,1024+nl-i*100],'color','r')
    end
end
if nc>0;
    for i=0:cc+1
    plot([nc+1+i*100,nc+1+i*100],[0,1024],'color','r')
    end
else
    for i=0:cc+1
        plot([1024+nc-i*100,1024+nc-i*100],[0,1024],'color','r')
    end
end
        if (nl>0)&&(nc>=0);
            conim=handles.sum1((nl+1:nl+ll*100),(nc+1:nc+cc*100));
            expim=reg_im((nl+1:nl+ll*100),(nc+1:nc+cc*100));
        end
        if (nl<0)&&(nc<0);
            conim=handles.sum1((1:ll*100),(1:cc*100));
            expim=reg_im((1:ll*100),(1:cc*100));
        end
        if(nl>=0)&&(nc<0);
          conim=handles.sum1((nl+1:nl+ll*100),(1:cc*100));
          expim=reg_im((nl+1:nl+ll*100),(1:cc*100));
        end
        if(nl<=0)&&(nc>=0);
          conim=handles.sum1((1:ll*100),(nc+1:nc+cc*100));
          expim=reg_im((1:ll*100),(nc+1:nc+cc*100));
        end

        expim=(expim-min(min(expim)))/(max(max(expim))-min(min(expim)));
        conim=(conim-min(min(conim)))/(max(max(conim))-min(min(conim))); 
        expim=colfilt(expim,[3,3],'sliding',@median);
        conim=colfilt(conim,[3,3],'sliding',@median); 
        handles.con=conim;
        handles.exp=expim;
        guidata(gcbo,handles)


% --- Executes on button press in pushbutton11.
function pushbutton11_Callback(hObject, eventdata, handles)                %%% To do blebbing analysis as Mode 1 (only two stacks)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
con0bk=handles.conbk;
xa=bwlabel(con0bk);                                                        %%% morphological analysis
labele=regionprops(xa,'Eccentricity');
labelc=regionprops(xa, 'Centroid');
labela=regionprops(xa,'Area');
labels=regionprops(xa,'Solidity');
ratioe=cat(2,labele.Eccentricity);
areae=cat(2,labela.Area);
lls=cat(2,labels.Solidity);
tt2=mean(areae([(areae>6)&(areae<625)]));                                  %%% to set the coase threshold for size
redmark=xa;
xxc=[];
add=0;
tte=0.9;
ttl=40;
meane=0;
meana=0;
for i=1:size(labele,1);
    if (labele(i).Eccentricity<tte)&&((labela(i).Area>ttl)&&(labela(i).Area<4*tt2)&&(lls(i)>0.7));
        xxc(add+1,:)=floor(labelc(i).Centroid);                            %%% ^^ conditions for fine selection of blebs
        redmark=redmark.*(redmark~=i)+0.5*(redmark==i);
        add=add+1;
        meane=meane+labele(i).Eccentricity;
        meana=meana+labela(i).Area;
    end
end                                                                        
prebleb=(redmark==0.5);
pfill=handles.pfill;
ffl=(200+0.6*pfill*10000);                                                 %%% set the threshold for the relatively intact dendrites                                               
idx=find([labela.Area]>ffl);
den=ismember(xa,idx);                                                      %%% record the relatively intact structure reference image
data=cell(2,14);                                                                      
data{1,1}='File';                                                          %%% to name the parameters saved in the following
data{1,2}='Percent';
data{1,3}='Mean(E)';
data{1,4}='Mean(A)';
data{1,5}='Area Th';
data{1,6}='Density';
data{1,7}='Im Size';
data{1,8}='Blocks';
data{1,9}='Blebs';
data{1,10}='Factor';
data{1,11}='Sframe';
data{1,12}='Prenum';
data{1,13}='M10mean';
data{1,14}='OTSU';
[pima,eimb,sframe]=corrtest(handles.file,handles.file2,pfill);             %%% for good frames selection based on correlation analysis
sum1=pima;
sum2=eimb;
[output Greg]=dftregistration(fft2(sum1),fft2(sum2),10);                   %%% image registration with translational way 
reg_im=abs(ifft2(Greg));
nl=round(output(3));
nc=round(output(4));
ll=floor((1024-abs(nl)-1)/100);
cc=floor((1024-abs(nc)-1)/100);
sum2=reg_im;
nnl=abs(nl);                                                               %%% to take the main match part after registration in the following
nnc=abs(nc);
        if (nl>0)&&(nc>=0);
            conbk=con0bk((nl+1:nl+ll*100),(nc+1:nc+cc*100));
            expim=sum2((nl+1:nl+ll*100),(nc+1:nc+cc*100));
            cden=den((nl+1:nl+ll*100),(nc+1:nc+cc*100));
            cprebleb=prebleb((nl+1:nl+ll*100),(nc+1:nc+cc*100));
        end
        if (nl<0)&&(nc<0);
            conbk=con0bk((1:ll*100),(1:cc*100));
            expim=sum2((1:ll*100),(1:cc*100));
            cden=den((1:ll*100),(1:cc*100));
            cprebleb=prebleb((1:ll*100),(1:cc*100));
        end
        if(nl>=0)&&(nc<0);
          conbk=con0bk((nl+1:nl+ll*100),(1:cc*100));
          expim=sum2((nl+1:nl+ll*100),(1:cc*100));
          cden=den((nl+1:nl+ll*100),(1:cc*100));
          cprebleb=prebleb((nl+1:nl+ll*100),(1:cc*100));
        end
        if(nl<=0)&&(nc>=0);
          conbk=con0bk((1:ll*100),(nc+1:nc+cc*100));
          expim=sum2((1:ll*100),(nc+1:nc+cc*100));
          cden=den((1:ll*100),(nc+1:nc+cc*100));
          cprebleb=prebleb((1:ll*100),(nc+1:nc+cc*100));
        end   
  expim=double(expim);
  expim=double((expim-min(min(expim)))/(max(max(expim))-min(min(expim))));
  expim=colfilt(expim,[3,3],'sliding',@median); 
  expimf=imfilter(expim,0.01*ones(10,10));
   [dn,dm]=size(expim);
  th=graythresh(expim);                                                    %%% OTSU's thresholding method   
  %thd=max(pfill/0.18,1)*th;
  exf=expimf(1:dn,1:dm);                                                   %%% crop the main part of the whole image to estimate the density
mf=blkproc(exf,[100,100],@mean2);
sumblock=(dn*dm)/10000;
lmf=reshape(mf,[1,sumblock]);
smf=sort(lmf,'descend');
mth=mean(smf(1:10));
tt=th*(2*mth/th*expimf+1-2*mth);                                           
  expbk=(expim>tt);
   xa=bwlabel(cprebleb);
  prenum=max(max(xa));
xa=bwlabel(expbk);
labele=regionprops(xa,'Eccentricity');
labelc=regionprops(xa, 'Centroid');
labela=regionprops(xa,'Area');
labels=regionprops(xa,'Solidity');
ratioe=cat(2,labele.Eccentricity);
areae=cat(2,labela.Area);
lls=cat(2,labels.Solidity);
tt2=mean(areae([(areae>6)&(areae<625)]));                                  %%% to set the coase threshold for size
redmark=xa;
xxc=[];
add=0;
tte=0.9;
ttl=40;
meane=0;
meana=0;
for i=1:size(labele,1);
    if (labele(i).Eccentricity<tte)&&((labela(i).Area>ttl)&&(labela(i).Area<4*tt2)&&(lls(i)>0.7));
        xxc(add+1,:)=floor(labelc(i).Centroid);
        redmark=redmark.*(redmark~=i)+0.5*(redmark==i);
        add=add+1;
        meane=meane+labele(i).Eccentricity;
        meana=meana+labela(i).Area;
    end
end
if add==0;
meane=0;
meana=0;
areath=4*tt2;
nnb=add;
percentb=0;
else  
meane=meane/add;
meana=meana/add;
areath=4*tt2;
nnb=add;
redmark=(redmark==0.5);
cenim=zeros(dn,dm);
for i=1:add;
cenim(xxc(i,2),xxc(i,1))=1;                                                %%% central coordinates of blebs
end
dcden=bwmorph(cden,'dilate',floor(40*(1-pfill)));
pcenim=cenim.*dcden.*(~cprebleb);                                          %%% select blebs in test imagee not covered by preblebs and on a string
%pcenim=cenim.*(~cprebleb);                                                %%% select blebs in test imagee not covered by preblebs
[x,y]=find(pcenim==1);
pxy=floor([y,x]);
rlabel=bwlabel(redmark);
rlabs=regionprops(rlabel,'Centroid');
cenp=floor(cat(1,rlabs.Centroid));
flabel=rlabel;
lm=size(cenp,1);
fnum=0;
ffp=[];
for i=1:lm;
    for jk=1:size(pxy,1);
    if cenp(i,:)==pxy(jk,:)
     flabel=flabel.*(flabel~=i)+0.5*(flabel==i); 
     fnum=fnum+1;
     ffp(fnum,:)=cenp(i,:);
    end
    end
end
redmark=(flabel==0.5);
fpim=zeros(dn,dm);
for i=1:fnum;    
fpim(ffp(i,2),ffp(i,1))=1;
end                                                                        %%% can use 'fpnum=sum(sum(fpim))' to show number of blebs
nb=100;
f2= @(x) ones(nb*nb,1)*sum(x);
temp=colfilt(cden,[nb,nb],'distinct',f2);
selectp=(temp>0.5*ffl);
nexp=colfilt(expbk,[nb,nb],'distinct',f2);
bexp=(nexp>0.25*ffl).*((nexp./temp)>0.25);
selectp=selectp.*bexp;
dmark=bwmorph(redmark,'dilate',floor(10*(1-pfill)));
bden=selectp.*(cden.*dmark);
temp2=colfilt(bden,[nb,nb],'distinct',f2);
selectb=(temp2>0);
fpim=fpim.*selectp;
nblock=sum(sum(selectp));
percentb=sum(sum(selectb))/nblock*100;                                     %%% previous way to calculate percentage of blebbed dendrites
temp3=colfilt(fpim,[nb,nb],'distinct',f2);
t1=sum(sum((temp3>=4)));
t2=sum(sum((temp3==3)));
t3=sum(sum((temp3==2)));
t4=sum(sum((temp3==1)));
w1=min(1,0.60/pfill*nnb/prenum*sumblock/prenum);
w2=min(1,0.24/pfill*nnb/prenum*sumblock/prenum);
w3=min(1,0.08/pfill*nnb/prenum*sumblock/prenum);
w4=min(1,0.02/pfill*nnb/prenum*sumblock/prenum);
cpercent=(t1*w1+t2*w2+t3*w3+t4*w4)/nblock*100
if (nnb<(1.05*prenum))||(nnb<(prenum+4))
cpercent=0.05*cpercent
if nnb==0;
cpercent=0;
end
end
end
%%%%%% Part five: for saving the results to excel file %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
j=2;
data{j,1}=handles.file2;
data{j,2}=percentb;
data{j,3}=meane;
data{j,4}=meana;
data{j,5}=areath;
data{j,6}=pfill;
data{j,7}=strcat(num2str(dn),'*',num2str(dm));
data{j,8}=strcat(num2str(sum(sum(selectb))/10000),'//',num2str(sum(sum(selectp))/10000));
data{j,9}=nnb;
data{j,10}=cpercent;
data{j,11}=strcat(num2str(sframe(1)),':',num2str(sframe(length(sframe))));
data{j,12}=prenum;
data{j,13}=mth;
data{j,14}=th;
pathn=handles.path;
pll=length(pathn);                                                         %%% for giving the file name in the following
for i=1:pll;
    pbb(i)=logical(length(str2num(pathn(i))));
end
pcc=bwlabel(pbb);
pdd=regionprops(pcc,'Area');
pee=cat(2,pdd.Area);
pml=max(pee);
if pml>4;
pix=find(pee==pml);
pff=(pcc==pix);
pgg=find(pff==1);
pname=pathn([pgg]);
else
    pname=strcat('bleb',num2str(floor(10*rand(1))));
end
fdate=date;
datafile=strcat('D:\shangbin chen\data\test13\',pname,'P%xx',fdate,'.xls');%%% to set the file path and name for saving results
xlswrite(datafile,data,'Sheet1','A1');
clear pbb                                                                  %%% to delete some variables for get memory space
clear pcc
clear pdd
clear pee
clear pml



% --- Executes on button press in pushbutton12. 
function pushbutton12_Callback(hObject, eventdata, handles)                %%% To do blebbing anaylysi in Mode 2
% hObject    handle to pushbutton12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filen,pathn] = uigetfile({'*.tif','2 or more image files'},'pick', 'MultiSelect', 'on');
tic                                                                        %%% start the timer recording
nn=size(filen)                                                             %%% filen is cell type  
num=nn(2);                                                                 %%% to get the number of files
filen=sort(filen);                                                         %%% the reference stack must be ranked as the first one!!
data=cell(num,14);                                                                      
data{1,1}='File';                                                          %%% to name the parameters saved in the following
data{1,2}='Percent';
data{1,3}='Mean(E)';
data{1,4}='Mean(A)';
data{1,5}='Area Th';
data{1,6}='Density';
data{1,7}='Im Size';
data{1,8}='Blocks';
data{1,9}='Blebs';
data{1,10}='Factor';
data{1,11}='Sframe';
data{1,12}='Prenum';
data{1,13}='M10mean';
data{1,14}='OTSU';
%%%%%% Part three: for processing the reference image %%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
file1=strcat(pathn,'\',filen{1});
for i=1:20;
    a(:,:,i)=imread(file1,i);
end
sum1=double(max(a,[],3));                                                  %%% May changeed to mean intensity projection
clear a;
conim0=(sum1-min(min(sum1)))/(max(max(sum1))-min(min(sum1)));
conim0=colfilt(conim0,[3,3],'sliding',@median);
expimf=imfilter(conim0,0.01*ones(10,10));
th0=graythresh(conim0)                                                     %%% OTSU's thresholding method 
tbk=(conim0>th0);
pfill=sum(sum(tbk))/(1024*1024)                                            %%% quantify the density
exf=expimf(1:1000,1:1000);                                                 %%% crop the main part of the whole image to estimate the density
mf=blkproc(exf,[100,100],@mean2);
lmf=reshape(mf,[1,100]);
smf=sort(lmf,'descend');
mth=mean(smf(1:10))
tt=th0*(2*mth/th0*expimf+1-2*mth);                                         %%% to implement adptive local thresholding           
con0bk=(conim0>tt);
xa=bwlabel(con0bk);                                                        %%% morphological analysis
labele=regionprops(xa,'Eccentricity');
labelc=regionprops(xa, 'Centroid');
labela=regionprops(xa,'Area');
labels=regionprops(xa,'Solidity');
ratioe=cat(2,labele.Eccentricity);
areae=cat(2,labela.Area);
lls=cat(2,labels.Solidity);
tt2=mean(areae([(areae>6)&(areae<625)]));                                  %%% to set the coase threshold for size
redmark=xa;
xxc=[];
add=0;
tte=0.9;
ttl=40;
meane=0;
meana=0;
for i=1:size(labele,1);
    if (labele(i).Eccentricity<tte)&&((labela(i).Area>ttl)&&(labela(i).Area<4*tt2)&&(lls(i)>0.7));
        xxc(add+1,:)=floor(labelc(i).Centroid);                            %%% ^^ conditions for fine selection of blebs
        redmark=redmark.*(redmark~=i)+0.5*(redmark==i);
        add=add+1;
        meane=meane+labele(i).Eccentricity;
        meana=meana+labela(i).Area;
    end
end                                                                        %%% ever used 'prenum=add' to record the number of blebs from reference image
prebleb=(redmark==0.5);
ffl=(200+0.6*pfill*10000);                                                 %%% set the threshold for the relatively intact dendrites                                               
idx=find([labela.Area]>ffl);
den=ismember(xa,idx);                                                      %%% record the relatively intact structure reference image

%%%%%% Part four: for processing the test images %%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j=2:num;
file=strcat(pathn,'\',filen{j});
[pima,eimb,sframe]=corrtest(file1,file,pfill);                             %%% for good frames selection with correlation analysis
disp(strcat('Busy on image...',num2str(j)))
sum1=pima;
sum2=eimb;
[output Greg]=dftregistration(fft2(sum1),fft2(sum2),10);                   %%% image registration with translational way 
reg_im=abs(ifft2(Greg));
nl=round(output(3));
nc=round(output(4));
ll=floor((1024-abs(nl)-1)/100);
cc=floor((1024-abs(nc)-1)/100);
sum2=reg_im;
nnl=abs(nl);                                                               %%% to take the main match part after registration in the following
nnc=abs(nc);
        if (nl>0)&&(nc>=0);
            conbk=con0bk((nl+1:nl+ll*100),(nc+1:nc+cc*100));
            expim=sum2((nl+1:nl+ll*100),(nc+1:nc+cc*100));
            cden=den((nl+1:nl+ll*100),(nc+1:nc+cc*100));
            cprebleb=prebleb((nl+1:nl+ll*100),(nc+1:nc+cc*100));
        end
        if (nl<0)&&(nc<0);
            conbk=con0bk((1:ll*100),(1:cc*100));
            expim=sum2((1:ll*100),(1:cc*100));
            cden=den((1:ll*100),(1:cc*100));
            cprebleb=prebleb((1:ll*100),(1:cc*100));
        end
        if(nl>=0)&&(nc<0);
          conbk=con0bk((nl+1:nl+ll*100),(1:cc*100));
          expim=sum2((nl+1:nl+ll*100),(1:cc*100));
          cden=den((nl+1:nl+ll*100),(1:cc*100));
          cprebleb=prebleb((nl+1:nl+ll*100),(1:cc*100));
        end
        if(nl<=0)&&(nc>=0);
          conbk=con0bk((1:ll*100),(nc+1:nc+cc*100));
          expim=sum2((1:ll*100),(nc+1:nc+cc*100));
          cden=den((1:ll*100),(nc+1:nc+cc*100));
          cprebleb=prebleb((1:ll*100),(nc+1:nc+cc*100));
        end   
  expim=double(expim);
  expim=double((expim-min(min(expim)))/(max(max(expim))-min(min(expim))));
  expim=colfilt(expim,[3,3],'sliding',@median); 
  expimf=imfilter(expim,0.01*ones(10,10));
   [dn,dm]=size(expim);
  th=graythresh(expim);                                                    %%% OTSU's thresholding method   
  exf=expimf(1:dn,1:dm);                                                   %%% crop the main part of the whole image to estimate the density
mf=blkproc(exf,[100,100],@mean2);
sumblock=(dn*dm)/10000;
lmf=reshape(mf,[1,sumblock]);
smf=sort(lmf,'descend');
mth=mean(smf(1:10))
tt=th*(2*mth/th*expimf+1-2*mth);                                           
  expbk=(expim>tt);
   xa=bwlabel(cprebleb);
  prenum=max(max(xa));
xa=bwlabel(expbk);
labele=regionprops(xa,'Eccentricity');
labelc=regionprops(xa, 'Centroid');
labela=regionprops(xa,'Area');
labels=regionprops(xa,'Solidity');
ratioe=cat(2,labele.Eccentricity);
areae=cat(2,labela.Area);
lls=cat(2,labels.Solidity);
tt2=mean(areae([(areae>6)&(areae<625)]));                                  %%% to set the coase threshold for size
redmark=xa;
xxc=[];
add=0;
tte=0.9;
ttl=40;
meane=0;
meana=0;
for i=1:size(labele,1);
    if (labele(i).Eccentricity<tte)&&((labela(i).Area>ttl)&&(labela(i).Area<4*tt2)&&(lls(i)>0.7));
        xxc(add+1,:)=floor(labelc(i).Centroid);
        redmark=redmark.*(redmark~=i)+0.5*(redmark==i);
        add=add+1;
        meane=meane+labele(i).Eccentricity;
        meana=meana+labela(i).Area;
    end
end
if add==0;
meane=0;
meana=0;
areath=4*tt2;
nnb=add;
percentb=0;
else  
meane=meane/add;
meana=meana/add;
areath=4*tt2;
nnb=add
redmark=(redmark==0.5);
cenim=zeros(dn,dm);
for i=1:add;
cenim(xxc(i,2),xxc(i,1))=1;                                                %%% central coordinates of blebs
end
dcden=bwmorph(cden,'dilate',floor(40*(1-pfill)));
pcenim=cenim.*dcden.*(~cprebleb);                                          %%% select blebs in test imagee not covered by preblebs and on a string
%pcenim=cenim.*(~cprebleb);                                                %%% select blebs in test imagee not covered by preblebs
[x,y]=find(pcenim==1);
pxy=floor([y,x]);
rlabel=bwlabel(redmark);
rlabs=regionprops(rlabel,'Centroid');
cenp=floor(cat(1,rlabs.Centroid));
flabel=rlabel;
lm=size(cenp,1);
fnum=0;
ffp=[];
for i=1:lm;
    for jk=1:size(pxy,1);
    if cenp(i,:)==pxy(jk,:)
     flabel=flabel.*(flabel~=i)+0.5*(flabel==i); 
     fnum=fnum+1;
     ffp(fnum,:)=cenp(i,:);
    end
    end
end
redmark=(flabel==0.5);
fpim=zeros(dn,dm);
for i=1:fnum;    
fpim(ffp(i,2),ffp(i,1))=1;
end                                                                        
nb=100;
f2= @(x) ones(nb*nb,1)*sum(x);
temp=colfilt(cden,[nb,nb],'distinct',f2);
selectp=(temp>0.5*ffl);
nexp=colfilt(expbk,[nb,nb],'distinct',f2);
bexp=(nexp>0.25*ffl).*((nexp./temp)>0.25);
selectp=selectp.*bexp;
dmark=bwmorph(redmark,'dilate',floor(10*(1-pfill)));
bden=selectp.*(cden.*dmark);
temp2=colfilt(bden,[nb,nb],'distinct',f2);
selectb=(temp2>0);
fpim=fpim.*selectp;
nblock=sum(sum(selectp))
percentb=sum(sum(selectb))/nblock*100;                                     %%% previous way to calculate percentage of blebbed dendrites
temp3=colfilt(fpim,[nb,nb],'distinct',f2);
t1=sum(sum((temp3>=4)));
t2=sum(sum((temp3==3)));
t3=sum(sum((temp3==2)));
t4=sum(sum((temp3==1)));
w1=min(1,0.60/pfill*nnb/prenum*sumblock/prenum);
w2=min(1,0.24/pfill*nnb/prenum*sumblock/prenum);
w3=min(1,0.08/pfill*nnb/prenum*sumblock/prenum);
w4=min(1,0.02/pfill*nnb/prenum*sumblock/prenum);
cpercent=(t1*w1+t2*w2+t3*w3+t4*w4)/nblock*100
if (nnb<(1.05*prenum))||(nnb<(prenum+4))
cpercent=0.05*cpercent
if nnb==0;
cpercent=0;
end
end
end

%%%%%% Part five: for saving the results to excel file %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
data{j,1}=filen{j};
data{j,2}=percentb;
data{j,3}=meane;
data{j,4}=meana;
data{j,5}=areath;
data{j,6}=pfill;
data{j,7}=strcat(num2str(dn),'*',num2str(dm));
data{j,8}=strcat(num2str(sum(sum(selectb))/10000),'//',num2str(sum(sum(selectp))/10000));
data{j,9}=nnb;
data{j,10}=cpercent;
data{j,11}=strcat(num2str(sframe(1)),':',num2str(sframe(length(sframe))));
data{j,12}=prenum;
data{j,13}=mth;
data{j,14}=th;
end
pll=length(pathn);                                                         %%% for giving the file name in the following
for i=1:pll;
    pbb(i)=logical(length(str2num(pathn(i))));
end
pcc=bwlabel(pbb);
pdd=regionprops(pcc,'Area');
pee=cat(2,pdd.Area);
pml=max(pee)
if pml>4;
pix=find(pee==pml);
pff=(pcc==pix);
pgg=find(pff==1);
pname=pathn([pgg]);
else
    pname=strcat('bleb',num2str(floor(10*rand(1))));
end
fdate=date;
datafile=strcat('D:\shangbin chen\data\test13\',pname,'P%xx',fdate,'.xls');
xlswrite(datafile,data,'Sheet1','A1');
clear pbb
clear pcc
clear pdd
clear pee
clear pml
toc


% --- Executes on button press in pushbutton13.
function pushbutton13_Callback(hObject, eventdata, handles)                %%% To do blebbing analysis as Mode 3
% hObject    handle to pushbutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[fnxls,pnxls] = uigetfile({'*.xls','Multiple image files'},'Loading the pathway file'); %% for load the stack files
fullnxls=strcat(pnxls,'\',fnxls);
tic 
%%%%%% Part one: for files loading from different folders %%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[nonnum,filedir]=xlsread(fullnxls,'Sheet6');                               %%% for loading the files from one excel file
numdir=length(filedir);                                                    %%% how many folders will be calculated
for di=1:numdir;                                                           %%% to do every folder by for loop
    pathn=filedir{di}                                                      %%% to get the files path
    files=dir(filedir{di});                                                %%% to get the files path
    prenum=length(files);
    kfile=[];
    for dj=3:prenum;
        [dind]=findstr(files(dj).name,'ch1');                              %%% only select the files from Channel 1 in 2-photon imaging 
        if dind>0;
            kfile=[kfile,dj];
        end
    end

%%%%%% Part two: for pre-setting data structure for saving results %%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
num=length(kfile);
filen=cell(1,num);
for fi=1:num;
filen{fi}=files(kfile(fi)).name;
end
filen=sort(filen);                                                         %%% the reference stack must be ranked as the first one!!
data=cell(num,14);                                                                      
data{1,1}='File';                                                          %%% to name the parameters saved in the following
data{1,2}='Percent';
data{1,3}='Mean(E)';
data{1,4}='Mean(A)';
data{1,5}='Area Th';
data{1,6}='Density';
data{1,7}='Im Size';
data{1,8}='Blocks';
data{1,9}='Blebs';
data{1,10}='Factor';
data{1,11}='Sframe';
data{1,12}='Prenum';
data{1,13}='M10mean';
data{1,14}='OTSU';
%%%%%% Part three: for processing the reference image %%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
file1=strcat(pathn,'\',filen{1});
for i=1:20;
    a(:,:,i)=imread(file1,i);
end
sum1=double(max(a,[],3));                                                  
clear a;
conim0=(sum1-min(min(sum1)))/(max(max(sum1))-min(min(sum1)));
conim0=colfilt(conim0,[3,3],'sliding',@median);
expimf=imfilter(conim0,0.01*ones(10,10));
th0=graythresh(conim0)                                                     %%% OTSU's thresholding method 
tbk=(conim0>th0);
pfill=sum(sum(tbk))/(1024*1024)                                            %%% quantify the density
exf=expimf(1:1000,1:1000);                                                 %%% crop the main part of the whole image to estimate the density
mf=blkproc(exf,[100,100],@mean2);
lmf=reshape(mf,[1,100]);
smf=sort(lmf,'descend');
mth=mean(smf(1:10))
tt=th0*(2*mth/th0*expimf+1-2*mth);                                         %%% adaptive local thresholding
con0bk=(conim0>tt);
xa=bwlabel(con0bk);                                                        %%% morphological analysis
labele=regionprops(xa,'Eccentricity');
labelc=regionprops(xa, 'Centroid');
labela=regionprops(xa,'Area');
labels=regionprops(xa,'Solidity');
ratioe=cat(2,labele.Eccentricity);
areae=cat(2,labela.Area);
lls=cat(2,labels.Solidity);
tt2=mean(areae([(areae>6)&(areae<625)]));                                  %%% to set the coase threshold for size
redmark=xa;
xxc=[];
add=0;
tte=0.9;
ttl=40;
meane=0;
meana=0;
for i=1:size(labele,1);
    if (labele(i).Eccentricity<tte)&&((labela(i).Area>ttl)&&(labela(i).Area<4*tt2)&&(lls(i)>0.7));
        xxc(add+1,:)=floor(labelc(i).Centroid);                            %%% ^^ conditions for fine selection of blebs
        redmark=redmark.*(redmark~=i)+0.5*(redmark==i);
        add=add+1;
        meane=meane+labele(i).Eccentricity;
        meana=meana+labela(i).Area;
    end
end                                                                        %%% ever used 'prenum=add' to record the number of blebs from reference image
prebleb=(redmark==0.5);
ffl=(200+0.6*pfill*10000);                                                 %%% set the threshold for the relatively intact dendrites                                               
idx=find([labela.Area]>ffl);
den=ismember(xa,idx);                                                      %%% record the relatively intact structure reference image

%%%%%% Part four: for processing the test images %%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j=2:num;
file=strcat(pathn,'\',filen{j});
[pima,eimb,sframe]=corrtest(file1,file,pfill);                             %%% for good frames selection with correlation analysis
disp(strcat('Busy on image...',num2str(j)))
sum1=double(pima);
sum2=double(eimb);
[output Greg]=dftregistration(fft2(sum1),fft2(sum2),10);                   %%% image registration with translational way 
reg_im=abs(ifft2(Greg));
nl=round(output(3));
nc=round(output(4));
ll=floor((1024-abs(nl)-1)/100);
cc=floor((1024-abs(nc)-1)/100);
sum2=reg_im;
nnl=abs(nl);                                                               %%% to take the main match part after registration in the following
nnc=abs(nc);
        if (nl>0)&&(nc>=0);
            conbk=con0bk((nl+1:nl+ll*100),(nc+1:nc+cc*100));
            expim=sum2((nl+1:nl+ll*100),(nc+1:nc+cc*100));
            cden=den((nl+1:nl+ll*100),(nc+1:nc+cc*100));
            cprebleb=prebleb((nl+1:nl+ll*100),(nc+1:nc+cc*100));
        end
        if (nl<0)&&(nc<0);
            conbk=con0bk((1:ll*100),(1:cc*100));
            expim=sum2((1:ll*100),(1:cc*100));
            cden=den((1:ll*100),(1:cc*100));
            cprebleb=prebleb((1:ll*100),(1:cc*100));
        end
        if(nl>=0)&&(nc<0);
          conbk=con0bk((nl+1:nl+ll*100),(1:cc*100));
          expim=sum2((nl+1:nl+ll*100),(1:cc*100));
          cden=den((nl+1:nl+ll*100),(1:cc*100));
          cprebleb=prebleb((nl+1:nl+ll*100),(1:cc*100));
        end
        if(nl<=0)&&(nc>=0);
          conbk=con0bk((1:ll*100),(nc+1:nc+cc*100));
          expim=sum2((1:ll*100),(nc+1:nc+cc*100));
          cden=den((1:ll*100),(nc+1:nc+cc*100));
          cprebleb=prebleb((1:ll*100),(nc+1:nc+cc*100));
        end   
  expim=double(expim);
  expim=double((expim-min(min(expim)))/(max(max(expim))-min(min(expim))));
  expim=colfilt(expim,[3,3],'sliding',@median); 
  expimf=imfilter(expim,0.01*ones(10,10));
   [dn,dm]=size(expim);
  th=graythresh(expim);                                                    %%% OTSU's thresholding method   
  %thd=max(pfill/0.18,1)*th;
  exf=expimf(1:dn,1:dm);                                                   %%% crop the main part of the whole image to estimate the density
mf=blkproc(exf,[100,100],@mean2);
sumblock=(dn*dm)/10000;
lmf=reshape(mf,[1,sumblock]);
smf=sort(lmf,'descend');
mth=mean(smf(1:10))
tt=th*(2*mth/th*expimf+1-2*mth);                                           
  expbk=(expim>tt);
   xa=bwlabel(cprebleb);
  prenum=max(max(xa));
xa=bwlabel(expbk);
labele=regionprops(xa,'Eccentricity');
labelc=regionprops(xa, 'Centroid');
labela=regionprops(xa,'Area');
labels=regionprops(xa,'Solidity');
ratioe=cat(2,labele.Eccentricity);
areae=cat(2,labela.Area);
lls=cat(2,labels.Solidity);
tt2=mean(areae([(areae>6)&(areae<625)]));                                  %%% to set the coase threshold for size
redmark=xa;
xxc=[];
add=0;
tte=0.9;
ttl=40;
meane=0;
meana=0;
for i=1:size(labele,1);
    if (labele(i).Eccentricity<tte)&&((labela(i).Area>ttl)&&(labela(i).Area<4*tt2)&&(lls(i)>0.7));
        xxc(add+1,:)=floor(labelc(i).Centroid);
        redmark=redmark.*(redmark~=i)+0.5*(redmark==i);
        add=add+1;
        meane=meane+labele(i).Eccentricity;
        meana=meana+labela(i).Area;
    end
end
if add==0;
meane=0;
meana=0;
areath=4*tt2;
nnb=add;
percentb=0;
else  
meane=meane/add;
meana=meana/add;
areath=4*tt2;
nnb=add
redmark=(redmark==0.5);
cenim=zeros(dn,dm);
for i=1:add;
cenim(xxc(i,2),xxc(i,1))=1;                                                %%% central coordinates of blebs
end
dcden=bwmorph(cden,'dilate',floor(40*(1-pfill)));
pcenim=cenim.*dcden.*(~cprebleb);                                          %%% select blebs in test imagee not covered by preblebs and on a string
%pcenim=cenim.*(~cprebleb);                                                %%% select blebs in test imagee not covered by preblebs
[x,y]=find(pcenim==1);
pxy=floor([y,x]);
rlabel=bwlabel(redmark);
rlabs=regionprops(rlabel,'Centroid');
cenp=floor(cat(1,rlabs.Centroid));
flabel=rlabel;
lm=size(cenp,1);
fnum=0;
ffp=[];
for i=1:lm;
    for jk=1:size(pxy,1);
    if cenp(i,:)==pxy(jk,:)
     flabel=flabel.*(flabel~=i)+0.5*(flabel==i); 
     fnum=fnum+1;
     ffp(fnum,:)=cenp(i,:);
    end
    end
end
redmark=(flabel==0.5);
fpim=zeros(dn,dm);
for i=1:fnum;    
fpim(ffp(i,2),ffp(i,1))=1;
end                                                                        %%% can use 'fpnum=sum(sum(fpim))' to show number of blebs
nb=100;
f2= @(x) ones(nb*nb,1)*sum(x);
temp=colfilt(cden,[nb,nb],'distinct',f2);
selectp=(temp>0.5*ffl);
nexp=colfilt(expbk,[nb,nb],'distinct',f2);
bexp=(nexp>0.25*ffl).*((nexp./temp)>0.25);
selectp=selectp.*bexp;
dmark=bwmorph(redmark,'dilate',floor(10*(1-pfill)));
bden=selectp.*(cden.*dmark);
temp2=colfilt(bden,[nb,nb],'distinct',f2);
selectb=(temp2>0);
fpim=fpim.*selectp;
nblock=sum(sum(selectp))
percentb=sum(sum(selectb))/nblock*100;                                     %%% previous way to calculate percentage of blebbed dendrites
temp3=colfilt(fpim,[nb,nb],'distinct',f2);
t1=sum(sum((temp3>=4)));
t2=sum(sum((temp3==3)));
t3=sum(sum((temp3==2)));
t4=sum(sum((temp3==1)));
w1=min(1,0.60/pfill*nnb/prenum*sumblock/prenum);
w2=min(1,0.24/pfill*nnb/prenum*sumblock/prenum);
w3=min(1,0.08/pfill*nnb/prenum*sumblock/prenum);
w4=min(1,0.02/pfill*nnb/prenum*sumblock/prenum);
cpercent=(t1*w1+t2*w2+t3*w3+t4*w4)/nblock*100
if (nnb<(1.05*prenum))||(nnb<(prenum+4))
cpercent=0.05*cpercent
if nnb==0;
cpercent=0;
end
end
end

%%%%%% Part five: for saving the results to excel file %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
data{j,1}=filen{j};
data{j,2}=percentb;
data{j,3}=meane;
data{j,4}=meana;
data{j,5}=areath;
data{j,6}=pfill;
data{j,7}=strcat(num2str(dn),'*',num2str(dm));
data{j,8}=strcat(num2str(sum(sum(selectb))/10000),'//',num2str(sum(sum(selectp))/10000));
data{j,9}=nnb;
data{j,10}=cpercent;
data{j,11}=strcat(num2str(sframe(1)),':',num2str(sframe(length(sframe))));
data{j,12}=prenum;
data{j,13}=mth;
data{j,14}=th;
end
pll=length(pathn);                                                         %%% for giving the file name in the following
for i=1:pll;
    pbb(i)=logical(length(str2num(pathn(i))));
end
pcc=bwlabel(pbb);
pdd=regionprops(pcc,'Area');
pee=cat(2,pdd.Area);
pml=max(pee)
if pml>4;
pix=find(pee==pml);
pff=(pcc==pix);
pgg=find(pff==1);
pname=pathn([pgg]);
else
    pname=strcat('bleb',num2str(floor(10*rand(1))));
end
fdate=date;
datafile=strcat('D:\shangbin chen\data\test13\',pname,'P%20',fdate,'.xls');
xlswrite(datafile,data,'Sheet1','A1');
clear pbb
clear pcc
clear pdd
clear pee
clear pml
end
toc

%%%%%% Part six: subroutine for selecting good frames %%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [pima,eimb,sframe]=corrtest(fn1,fn2,pfill)
for i=1:20;
cc=imread(fn2,i);
dd(:,i)=cc(:);
end
rr=corrcoef(double(dd));
aa=diag(rr,-1);
bb=(aa>(0.55+0.5*pfill));
cc=bwlabel(bb);
add=regionprops(cc,'Area');
ee=cat(2,add.Area);
ix=find(ee==max(ee));
lix=length(ix);
if lix==0;
    sframe=19:20;
    gg=19;
else
ff=(cc==ix(lix));
gg=find(ff==1);
sframe=gg(1):(gg(1)+length(gg));
end
for i=1:20;
prim(:,:,i)=imread(fn1,i);
exim(:,:,i)=imread(fn2,i);
end
pima=max(prim,[],3);
eimb=max(exim(:,:,(gg(1):(gg(1)+length(gg)))),[],3);



